"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const dynamic_object_factory_1 = require("../graphql/dynamic-object.factory");
const typedi_1 = require("typedi");
const type_graphql_1 = require("type-graphql");
function RelayedField(type, throughOrOptions, options) {
    return (target, propertyKey) => {
        let through;
        if (typeof throughOrOptions === "function") {
            through = throughOrOptions;
        }
        else {
            options = throughOrOptions;
        }
        process.nextTick(() => {
            const dynamicObjectFactory = typedi_1.Container.get(dynamic_object_factory_1.DynamicObjectFactory);
            const { Connection } = dynamicObjectFactory.getEdgeConnection(type, through, { field: options });
            type_graphql_1.Field(() => Connection, options)(target, propertyKey);
        });
    };
}
exports.RelayedField = RelayedField;
//# sourceMappingURL=relayed-field.decorator.js.map