import { RelayedConnectionOptions } from './../decorators/relayed-connection.decorator';
import { TypeValue, ClassValueThunk } from '../types/types';
import { ClassType } from 'type-graphql';
import * as Relay from 'graphql-relay';
export declare class DynamicObjectFactory {
    protected edgeConnectionCache: Map<string, ConnectionEdgeType<any>>;
    getEdgeConnection<T = any>(to: ClassValueThunk<T>, through?: ClassValueThunk<any>, options?: RelayedConnectionOptions): ConnectionEdgeType<T>;
    declareFunctionAsRelayInSDL<T extends TypeValue>(target: any, functionName: string, sdlName: string | symbol, Connection: new () => Relay.Connection<T>, options?: RelayedConnectionOptions): void;
    protected makeEdge<T extends TypeValue>(connectionName: string, to: () => T, through: () => new () => any): ClassType<Relay.Edge<T>>;
    protected makeConnection<T extends TypeValue>(connectionName: string, Edge: ClassType<Relay.Edge<T>>, PageInfo: ClassType<Relay.PageInfo>, options?: RelayedConnectionOptions): ClassType<Relay.Connection<T>>;
    protected getBaseConnection(): ClassValueThunk<any>;
    protected getPageInfo(): ClassType<Relay.PageInfo>;
    protected getConnectionName(to: ClassValueThunk<any>, through?: ClassValueThunk<any>): string;
    protected getPrefix(): string;
}
export declare type ConnectionEdgeType<T = any> = {
    Connection: ClassType<Relay.Connection<ClassType<T>>>;
    Edge: ClassType<Relay.Edge<ClassType<T>>>;
};
