"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const auto_relay_config_service_1 = require("./../services/auto-relay-config.service");
const typedi_1 = require("typedi");
const type_graphql_1 = require("type-graphql");
const Relay = __importStar(require("graphql-relay"));
let DynamicObjectFactory = class DynamicObjectFactory {
    constructor() {
        this.edgeConnectionCache = new Map();
    }
    getEdgeConnection(to, through = () => Object, options) {
        const connectionName = this.getConnectionName(to, through);
        if (!this.edgeConnectionCache.has(connectionName)) {
            const PageInfo = this.getPageInfo();
            const Edge = this.makeEdge(connectionName, to, through);
            const Connection = this.makeConnection(connectionName, Edge, PageInfo, options);
            this.edgeConnectionCache.set(connectionName, { Edge, Connection });
        }
        return this.edgeConnectionCache.get(connectionName);
    }
    declareFunctionAsRelayInSDL(target, functionName, sdlName, Connection, options) {
        const fieldOptions = options && options.field;
        if (fieldOptions && fieldOptions.nullable)
            fieldOptions.nullable = undefined;
        Reflect.defineMetadata('design:paramtypes', [String, Number, String, Number], target, functionName);
        type_graphql_1.Arg('after', () => String, { nullable: true })(target, functionName, 0);
        type_graphql_1.Arg('first', () => type_graphql_1.Int, { nullable: true })(target, functionName, 1);
        type_graphql_1.Arg('before', () => String, { nullable: true })(target, functionName, 2);
        type_graphql_1.Arg('last', () => type_graphql_1.Int, { nullable: true })(target, functionName, 3);
        type_graphql_1.Field(() => Connection, { name: `${String(sdlName)}`, ...fieldOptions })(target, functionName, { value: true });
    }
    makeEdge(connectionName, to, through) {
        const Edge = class extends through().prototype.constructor {
        };
        Object.assign(Edge, through());
        type_graphql_1.Field(to)(Edge.prototype, 'node');
        type_graphql_1.Field(() => String, { description: 'Used in `before` and `after` args' })(Edge.prototype, 'cursor');
        type_graphql_1.ObjectType(`${this.getPrefix()}${connectionName}Edge`)(Edge);
        return Edge;
    }
    makeConnection(connectionName, Edge, PageInfo, options) {
        const nullable = options && options.field && options.field.nullable;
        const baseClass = this.getBaseConnection();
        let Connection = class Connection extends baseClass() {
        };
        __decorate([
            type_graphql_1.Field(() => PageInfo),
            __metadata("design:type", Object)
        ], Connection.prototype, "pageInfo", void 0);
        __decorate([
            type_graphql_1.Field(() => [Edge], { nullable }),
            __metadata("design:type", Array)
        ], Connection.prototype, "edges", void 0);
        Connection = __decorate([
            type_graphql_1.ObjectType(`${this.getPrefix()}${connectionName}Connection`)
        ], Connection);
        return Connection;
    }
    getBaseConnection() {
        try {
            return typedi_1.Container.get(auto_relay_config_service_1.CONNECTION_BASE_OBJECT);
        }
        catch (e) { }
        return () => Object;
    }
    getPageInfo() {
        try {
            let PageInfoFn;
            try {
                PageInfoFn = typedi_1.Container.get(auto_relay_config_service_1.PAGINATION_OBJECT);
            }
            catch (e) {
                auto_relay_config_service_1.AutoRelayConfig.generateObjects();
                PageInfoFn = typedi_1.Container.get(auto_relay_config_service_1.PAGINATION_OBJECT);
            }
            const PageInfo = PageInfoFn();
            if (!PageInfo)
                throw new Error(`Couldn't find or generate PageInfo Object`);
            return PageInfo;
        }
        catch (e) {
            throw new Error(`Couldn't find or generate PageInfo Object`);
        }
    }
    getConnectionName(to, through) {
        return `${through && through().name !== "Object" ? through().name : ''}${to().name}`;
    }
    getPrefix() {
        try {
            return typedi_1.Container.get(auto_relay_config_service_1.PREFIX);
        }
        catch (e) {
            return "";
        }
    }
};
DynamicObjectFactory = __decorate([
    typedi_1.Service()
], DynamicObjectFactory);
exports.DynamicObjectFactory = DynamicObjectFactory;
//# sourceMappingURL=dynamic-object.factory.js.map