"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_clonedeep_1 = __importDefault(require("lodash.clonedeep"));
function augmentedConnection(connection, throughKey) {
    const newConnection = lodash_clonedeep_1.default(connection);
    newConnection.edges = newConnection.edges.map((e) => {
        const newEdge = { ...e.node, ...e };
        newEdge.node = e.node[throughKey];
        return newEdge;
    });
    return newConnection;
}
exports.augmentedConnection = augmentedConnection;
//# sourceMappingURL=augment-connection.function.js.map