import { LimitOffsetOptions } from './../decorators/relayed-query.decorator';
import { ClassValueThunk } from '../types/types';
import { ORMConnection } from '../orm/orm-connection.abstract';
import * as Relay from "graphql-relay";
export declare type AutoRelayConfigArgs = AutoRelayConfigArgsExistingModel | AutoRelayConfigArgsNoModel;
export declare type AutoRelayOrmConnect<T extends ORMConnection = ORMConnection> = () => new () => T;
export interface AutoRelayConfigArgsBase {
    orm: AutoRelayOrmConnect;
    sort?: {};
    pagination?: LimitOffsetOptions;
}
export interface AutoRelayConfigArgsExistingModel extends AutoRelayConfigArgsBase {
    objects: {
        pageInfo: ClassValueThunk<Relay.PageInfo>;
        connectionArgs: ClassValueThunk<Relay.ConnectionArguments>;
    };
}
export interface AutoRelayConfigArgsNoModel extends AutoRelayConfigArgsBase {
    microserviceName?: string;
    extends?: {
        pageInfo?: ClassValueThunk<any>;
        connection?: ClassValueThunk<any>;
    };
}
