import { RelayedConnectionOptions } from './../decorators/relayed-connection.decorator';
import { ClassValueThunk } from '..';
import { AugmentedConnection } from '../interfaces/augmented-connection.interface';
import * as Relay from 'graphql-relay';
export declare abstract class ORMConnection {
    abstract autoRelayFactory<T = any, Y = any>(field: string, self: ClassValueThunk, type: ClassValueThunk<T>, through?: ClassValueThunk<Y>, options?: RelayedConnectionOptions<Y>): AutoRelayGetter<T, Y>;
    abstract autoRelayFactory<T = any>(field: string, self: ClassValueThunk, type: ClassValueThunk<T>, through?: undefined, options?: RelayedConnectionOptions<T>): AutoRelayGetter<T, undefined>;
    abstract getColumnsOfFields(entity: ClassValueThunk, keys: string[]): Record<string, string | undefined>;
}
export declare type AutoRelayGetter<T = any, Y = any> = (after?: Relay.ConnectionCursor, first?: number, before?: Relay.ConnectionCursor, last?: number) => AugmentedConnection<T, Y> | Promise<AugmentedConnection<T, Y>>;
