import { SharedObjectFactory } from '../graphql/shared-object.factory';
import { Token } from 'typedi';
import { AutoRelayConfigArgs, AutoRelayConfigArgsExistingModel, AutoRelayConfigArgsNoModel } from '../interfaces/auto-relay-config.interface';
import { ClassValueThunk, ORMConnection } from '..';
import * as Relay from 'graphql-relay';
export declare const CONFIG: Token<AutoRelayConfigArgs>;
export declare const PREFIX: Token<string>;
export declare const CONNECTION_BASE_OBJECT: Token<ClassValueThunk<any>>;
export declare const PAGINATION_OBJECT: Token<ClassValueThunk<Relay.PageInfo>>;
export declare const CONNECTIONARGS_OBJECT: Token<ClassValueThunk<Relay.ConnectionArguments>>;
export declare const ORM_CONNECTION: Token<ORMConnection>;
export declare class AutoRelayConfig {
    protected static _sharedObjectFactory: SharedObjectFactory;
    protected static _config: AutoRelayConfigArgs;
    constructor(config: AutoRelayConfigArgs);
    static generateObjects(config?: AutoRelayConfigArgsNoModel, force?: boolean): void;
    protected static paginationExists(): boolean;
    protected _registerOrm(config: AutoRelayConfigArgs): void;
    protected _declareExistingObjects(config: AutoRelayConfigArgsExistingModel): void;
}
