"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var AutoRelayConfig_1;
Object.defineProperty(exports, "__esModule", { value: true });
const shared_object_factory_1 = require("../graphql/shared-object.factory");
const typedi_1 = require("typedi");
exports.CONFIG = new typedi_1.Token('CONFIG');
exports.PREFIX = new typedi_1.Token('PREFIX');
exports.CONNECTION_BASE_OBJECT = new typedi_1.Token('CONNECTION_BASE_OBJECT');
exports.PAGINATION_OBJECT = new typedi_1.Token('PAGINATION_OBJECT');
exports.CONNECTIONARGS_OBJECT = new typedi_1.Token('CONNECTIONARGS_OBJECT');
exports.ORM_CONNECTION = new typedi_1.Token('ORM_CONNECTION');
let AutoRelayConfig = AutoRelayConfig_1 = class AutoRelayConfig {
    constructor(config) {
        if (!config)
            throw new Error(`No config supplied to AutoRelay`);
        typedi_1.Container.remove(exports.PAGINATION_OBJECT);
        typedi_1.Container.remove(exports.CONNECTIONARGS_OBJECT);
        this._registerOrm(config);
        if (config.objects) {
            this._declareExistingObjects(config);
        }
        else {
            const configNoModel = config;
            configNoModel.microserviceName = configNoModel.microserviceName ? String(configNoModel.microserviceName) : '';
            if (configNoModel.microserviceName) {
                configNoModel.microserviceName = configNoModel.microserviceName[0].toUpperCase() + configNoModel.microserviceName.substring(1);
            }
            AutoRelayConfig_1.generateObjects(config, true);
            typedi_1.Container.set(exports.PREFIX, configNoModel.microserviceName);
            if (configNoModel.extends && configNoModel.extends.connection) {
                typedi_1.Container.set(exports.CONNECTION_BASE_OBJECT, configNoModel.extends.connection);
            }
            else {
                typedi_1.Container.set(exports.CONNECTION_BASE_OBJECT, () => Object);
            }
        }
        AutoRelayConfig_1._config = config;
        typedi_1.Container.set(exports.CONFIG, config);
    }
    static generateObjects(config, force = false) {
        config = config || AutoRelayConfig_1._config;
        const alreadyExists = this.paginationExists();
        if (!alreadyExists || force) {
            const ConnectionArgs = this._sharedObjectFactory.generateConnectionArgs(config.microserviceName || "");
            const PageInfo = this._sharedObjectFactory.generatePageInfo(config.microserviceName || "", config.extends ? config.extends.pageInfo : undefined);
            typedi_1.Container.set(exports.PAGINATION_OBJECT, () => PageInfo);
            typedi_1.Container.set(exports.CONNECTIONARGS_OBJECT, () => ConnectionArgs);
        }
    }
    static paginationExists() {
        let alreadyExists;
        try {
            alreadyExists = Boolean(typedi_1.Container.get(exports.PAGINATION_OBJECT));
        }
        catch (e) {
            alreadyExists = false;
        }
        return alreadyExists;
    }
    _registerOrm(config) {
        if (!config.orm || typeof config.orm !== 'function')
            throw new Error(`config.orm must be a function`);
        typedi_1.Container.set(exports.ORM_CONNECTION, new (config.orm())());
    }
    _declareExistingObjects(config) {
        typedi_1.Container.set(exports.PAGINATION_OBJECT, config.objects.pageInfo);
        typedi_1.Container.set(exports.CONNECTIONARGS_OBJECT, config.objects.connectionArgs);
    }
};
AutoRelayConfig._sharedObjectFactory = typedi_1.Container.get(shared_object_factory_1.SharedObjectFactory);
AutoRelayConfig._config = {};
AutoRelayConfig = AutoRelayConfig_1 = __decorate([
    typedi_1.Service(),
    __metadata("design:paramtypes", [Object])
], AutoRelayConfig);
exports.AutoRelayConfig = AutoRelayConfig;
//# sourceMappingURL=auto-relay-config.service.js.map