import * as Relay from 'graphql-relay';
export declare class LimitOffsetPagingService {
    getLimitOffset(args: Relay.ConnectionArguments): {
        limit?: number;
        offset?: number;
    };
    protected _checkPagingSanity(args: Relay.ConnectionArguments): PagingMeta;
    protected _getId(cursor: Relay.ConnectionCursor): number;
    protected _nextId(cursor: Relay.ConnectionCursor): number;
}
declare type PagingMeta = ForwardPaging | BackwardPaging | NoPaging;
interface ForwardPaging {
    pagingType: 'forward';
    after?: string;
    first: number;
}
interface BackwardPaging {
    pagingType: 'backward';
    before: string;
    last: number;
}
interface NoPaging {
    pagingType: 'none';
}
export {};
