"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const typedi_1 = require("typedi");
const dynamic_object_factory_1 = require("../graphql/dynamic-object.factory");
const relay_from_array_count_middleware_1 = require("../middlewares/relay-from-array-count.middleware");
const type_graphql_1 = require("type-graphql");
const auto_relay_config_service_1 = require("./auto-relay-config.service");
let RelayedQueryService = class RelayedQueryService {
    makeMethodRelayedQuery(target, propertyKey, descriptor, to, through, options) {
        this.relayQueryOrFieldResolver(target, propertyKey, descriptor, to, through, options);
    }
    makeMethodRelayedFieldResolver(target, propertyKey, descriptor, to, through, options) {
        this.relayQueryOrFieldResolver(target, propertyKey, descriptor, to, through, options, true);
    }
    relayQueryOrFieldResolver(target, propertyKey, descriptor, to, through, options, isFieldResolver = false) {
        Reflect.defineMetadata('autorelay:query:options', JSON.stringify({ ...this.getGlobalOptions(), ...options }), target, propertyKey);
        const queryName = this.getQueryName(propertyKey, options);
        const { Connection } = this.makeEdgeConnection(to, through);
        this.registerArgs(target, propertyKey, options);
        const middleware = relay_from_array_count_middleware_1.RelayFromArrayCountFactory(target, propertyKey);
        type_graphql_1.UseMiddleware(middleware)(target, propertyKey, descriptor);
        if (isFieldResolver) {
            type_graphql_1.FieldResolver(() => Connection, { ...options, name: queryName })(target, propertyKey, descriptor);
        }
        else {
            type_graphql_1.Query(() => Connection, { ...options, name: queryName })(target, propertyKey, descriptor);
        }
    }
    makeEdgeConnection(to, through) {
        const dynamicObjectFactory = typedi_1.Container.get(dynamic_object_factory_1.DynamicObjectFactory);
        return dynamicObjectFactory.getEdgeConnection(to, through);
    }
    getQueryName(propertyKey, options) {
        return options && options.name ? options.name : propertyKey;
    }
    registerArgs(target, propertyKey, options) {
        const ConnectionArgsThunk = typedi_1.Container.get(auto_relay_config_service_1.CONNECTIONARGS_OBJECT);
        const ConnectionArgs = ConnectionArgsThunk();
        if (options && options.paginationInputType) {
            const name = typeof options.paginationInputType === 'string' ? options.paginationInputType : 'pagination';
            Reflect.defineMetadata('autorelay:connectionArgs:key', name, target, propertyKey);
            type_graphql_1.Arg(name, () => ConnectionArgs, { nullable: true })(target, propertyKey, 99999999);
        }
        else {
            type_graphql_1.Args(() => ConnectionArgs)(target, propertyKey, 99999999);
        }
    }
    getGlobalOptions() {
        try {
            return { ...typedi_1.Container.get(auto_relay_config_service_1.CONFIG).pagination };
        }
        catch (e) {
        }
        return {};
    }
};
RelayedQueryService = __decorate([
    typedi_1.Service()
], RelayedQueryService);
exports.RelayedQueryService = RelayedQueryService;
//# sourceMappingURL=relay-query.service.js.map